{********************************************
	ALL FUNCTIONS BEGINNING WITH "rt"
	ARE PART OF THE RTLib488 TOOLS LIBRARY
********************************************}

{$m 32000,0,655360}
{$N+,E+}  {* Link with full 8087 emulator, uses 8087 if present *}
{$D-}     {* Turn off debugging *}
PROGRAM rtmsdem1(input,output);

USES crt, printer,graph, dos,rtmouse,rtstdhdr,rtgsubs, rtbargr,rtmeter,
     rtchart,rttext,rtgraph, rtgcommo;


var  orderformlen: INTEGER;
     orderform: array[0..25] of string[80];
     rr,xx1,yy1: RealType;
     xdata, ydata,ydata2,ydata3,ydata4: array[0..600] of realtype;
     tcxs, tcfitted, tcactual: array[0..60] of realtype;
     orderformfile,tcfile: TEXT;
     lalarm,halarm,stpnt,y3values,
     y2vals,y2values,yvalues: rtvaluearraytype;
     lc,lc2,lf : rtintarraytype;
     tags,units,halarms,lalarms,nalarms: tagarraytype;
     message: messagearraytype;
     alarmstrings: alarmstrarraytype;
     farray: rtbooleanarray;
     index: longint;
     ch: char;
     mousefound: BOOLEAN;
     mainaction,buttons: INTEGER;

  logvals: rtvaluearraytype;
  timeint, sampleint, miny, maxy, rt : realtype;
   nt, grid, xdecs, ydecs, i1,i2,i3: integer;



FUNCTION GetSeconds: REALTYPE;
var hours, minutes, seconds, hundreds: word;
    result: RealType;
BEGIN
  GetTime(hours, minutes, seconds, hundreds);
  result := hours*3600.0 + minutes * 60.0 + seconds + hundreds/100.0;
  GetSeconds := result;
END;

PROCEDURE RTCLEARSCREEN;
BEGIN
  IF mousefound THEN RTHideMouse;
  SetViewport(0,0,GetMaxX, GetMaxY,FALSE);
  clearviewport;
END;

FUNCTION CheckEvent: INTEGER;
VAR status,x,y: INTEGER;
    result: INTEGER;
BEGIN
  status := 0;
  IF mousefound THEN RTGetMouse(status,X,Y);
  result := 0;
  IF (status <> 0) THEN result := 2;
  IF keypressed THEN result := 1;
  CheckEvent := result;
END;

function getkey: CHAR;
VAR result,firstkey, secondkey: CHAR;
BEGIN
  secondkey := #0;
  if keypressed then
  begin
    firstkey := readkey;
    if keypressed then
      secondkey := readkey;
  end;
  if ((firstkey = #0) and (secondkey IN [#59..#68])) then
    result := chr( ord(secondkey)-10)
  else result := firstkey;
  getkey := result;
END;

procedure XText(VAR s1,s2,s3: string; n: INTEGER);
var lx,ly,lyinc,i,j: INTEGER;
    s: string;
begin
  RTSDRVp(rtstat[0]);
  ly := RTviewportheight div 2;
  lx := RTViewportwidth div 2;
  settextjustify(1,1);
  for j := 0 to 2 do
  begin
    case j of
    0: s := s1;
    1: s := s2;
    2: s := s3;
    end;
    ly := 4;
    lyinc := (rtviewportheight - 4) div 16;
    for i := 1  to  8 do
    begin
      inc(ly,lyinc);
      settextstyle(2,0,i);
      rtsetcolor(15);
      moveto(lx,ly);
      outtext(s);
      delay(50);
      if i <> 8 then
      begin
       rtsetcolor(rtstat[0]^.pbgcolor);
       moveto(lx,ly);
       outtext(s);
      end;
    end;
    moveto(lx+1,ly);
    outtext(s);
    delay(300);
    rtsetcolor(rtstat[0]^.pbgcolor);
    moveto(lx,ly);
    outtext(s);
    moveto(lx+1,ly);
    outtext(s);
  end
end;

PROCEDURE DrawDiagram(w: rtstatpntr);
BEGIN
  RTSetWindow(w);
  RTSetWorldCoordinates(0.0, 0.0, 1.0, 1.0);
  RTBarTextWorld(0.15,0.6, 0.3,0.15,'1/sTi', 9,0 );
  RTBarTextWorld( 0.45,0.3, 0.3,0.15,'Kc', 9,0 );
  RTBarTextWorld( 0.73,0.3, 0.3,0.18 ,'Kp/(1+sT)', 9,0 );

  RTCircleTextWorld( 0.075,0.45, 0.03 ,'X', 10,0 );
  RTCircleTextWorld( 0.35,0.45, 0.03 ,'X', 10,0 );
  RTCircleTextWorld( 0.675,0.45, 0.03 ,'X', 10,0 );

  rtsetcolor(15);

  RTMoveWorldAbs(0.01,0.45);
  RTLineWorldAbs(0.055,0.45);

  RTMoveWorldAbs(0.095,0.45);
  RTLineWorldAbs(0.33,0.45);

  RTMoveWorldAbs(0.37,0.45);
  RTLineWorldAbs(0.45,0.45);

  RTMoveWorldAbs(0.60,0.45);
  RTLineWorldAbs(0.655,0.45);

  RTMoveWorldAbs(0.695,0.45);
  RTLineWorldAbs(0.73,0.45);

  RTMoveWorldAbs(0.91,0.45);
  RTLineWorldAbs(0.99,0.45);

  RTMoveWorldAbs(0.95,0.45);
  RTLineWorldAbs(0.95,0.20);
  RTLineWorldAbs(0.075,0.20);
  RTLineWorldAbs(0.075,0.42);

  RTMoveWorldAbs(0.12,0.45);
  RTLineWorldAbs(0.12,0.75);
  RTLineWorldAbs(0.15,0.75);

  RTMoveWorldAbs(0.30,0.75);
  RTLineWorldAbs(0.35,0.75);
  RTLineWorldAbs(0.35,0.47);

  RTMoveWorldAbs(0.675,0.70);
  RTLineWorldAbs(0.675,0.46);


  RTMoveWorldAbs(0.04,0.47); OutText('+');
  RTMoveWorldAbs(0.05,0.38); OutText('-');

  RTMoveWorldAbs(0.36,0.47); OutText('+');
  RTMoveWorldAbs(0.32,0.38); OutText('+');


  RTMoveWorldAbs(0.635,0.46); OutText('+');
  RTMoveWorldAbs(0.695,0.46); OutText('-');

  RTMoveWorldAbs(0.01,0.53); OutText('R(s)');
  RTMoveWorldAbs(0.92,0.48); OutText('e(s)');
  RTMoveWorldAbs(0.680,0.70); OutText('L(s)');

  RTMoveWorldAbs(0.20,0.93); OutText('Reactor Model as a First Order System');

END;

procedure CWinText(win: rtstatpntr; y,c: INTEGER; s: string);
VAR xx,yy: INTEGER;
begin
  RTSDRVp(wIN);
  settextjustify(1,0);
  rtsetcolor(c);
  xx := rtviewportwidth div 2;
  yy := y * (2+textheight('x'))+2;
  MoveTo(xx,yy);
  OutText(s);
  settextjustify(0,0);
end;

PROCEDURE CBoldTitle(win: RTStatPntr; y,c: INTEGER; s: string);
VAR xx,yy: INTEGER;
BEGIN
  RTSDRVp(wIN);
  settextjustify(1,0);
  rtsetcolor(c);
  xx := rtviewportwidth div 2;
  yy := y * (2+textheight('x'))+4;
  MoveTo(xx,yy);
  OutText(s);
  MoveTo(xx+1,yy);
  OutText(s);
  settextjustify(0,0);
END;

PROCEDURE RTResetWindowDefaults(num: INTEGER);
VAR i: INTEGER;
BEGIN
  FOR i := 0 to num-1 Do
  BEGIN
    RTFreeWindow(rtstat[i]);
    RTInitWindow(rtstat[i]);
  END;
END;

{$I Scrol123.inc}

PROCEDURE BuildAp4;
var nr,nc,i,j,k : INTEGER;
    title ,units :string;
    hdata: array[0..49] of realtype;
    pinum: realtype;
    o2index, o2i: realtype;
    ahalarm, alalarm, astpnt: rtvaluearraytype;
    atags, aunits, ahalarms,alalarms, analarms: tagarraytype;
    cursec,startsec: realtype;

BEGIN
  RTCLEARSCREEN;
  RTResetWindowDefaults(20);
  hdata[0] := 0.0;   hdata[1] := 0.6;   hdata[2] := 0.75;  hdata[3] := 0.6;
  hdata[4] := -0.15; hdata[5] := -0.20; hdata[6] := -0.175;  hdata[7] := 0.15;
  hdata[8] := 0.2;   hdata[9] := 0.175;  hdata[10] := 0.0;  hdata[11] := 0.0;
  hdata[12] := 0.025; hdata[13] := 0.035; hdata[14] := 0.025;
  FOR i := 15 TO 49 DO hdata[i] := 0.0;

  FOR i := 0 TO 510 DO
  BEGIN
     ydata[i] := hdata[i mod 50];
     ydata2[i] := sin(PI*i/52) * (random) * 1.1;
     ydata3[i] := random-0.5;
  END;
  startsec := GetSeconds;
  atags[0] := 'SYSTOLIC';  atags[1]:= 'DIASTOLIC';
  atags[2] := 'PULSE';     atags[3]:= 'O2';
  for i := 0 to 3 do
  BEGIN
    if (i <= 3)  then farray[i] := true
    else farray[i] := false;
    lc[i] := 15;
    aunits[i] := '';
    alalarms[i]:= 'LAlarm';
    analarms[i]:= 'OK';
    ahalarms[i]:= 'HAlarm';
    alalarm[i] := -300.0;
    ahalarm[i] := 175.0;
    astpnt[i] := 4.0;
  END;


  rtsetpercentwindow(rtstat[0],0.01,0.01,0.6,0.6);
  rtsetpercentwindow(rtstat[1],0.01,0.61,0.6,1.0);
  rtsetpercentwindow(rtstat[2],0.61,0.01,0.9,0.3);
  rtsetpercentwindow(rtstat[3],0.61,0.31,0.78,0.76);
  rtsetpercentwindow(rtstat[4],0.61,0.76,0.85,1.0);


  nr := 2; nc := 2;
  IF (GetMaxColor=1) THEN
    rtinitwindowcolors(rtstat[2],0,0,0,0,15,15,15);
  rtsetupannun(rtstat[2], alalarm, ahalarm, astpnt, 1,'Vitals',
	       aunits,atags, ahalarms, alalarms,analarms,nr,nc,lc,farray);



  tags[0]:= 'TIME IN SECONDS';
  units:= 'Normalized';
  title:= 'EKG';

  nt :=1;
  for i := 0 to nt-1 do
  BEGIN
	lc[i] := 14-i;
	lf[i] := 0;
  END;

  for i := 0 to 1 do
  BEGIN
     rtinitwindowcolors(rtstat[i],0,0,9,12,15,15,15);
     rtsetupscrollgraph(rtstat[i],5.0, 0.02, -1.0, 1.0, 0.9,
		      1, 0, -0.8, 0.8, 200.0, 2,1,title, units,
		      tags, lc, lf, false);
     lc[0] := 12;
     rtborderwindow(rtstat[i],15);
     title := 'Brain Wave';
  END;

  alarmstrings[0]:= 'LAlarm';
  alarmstrings[1]:= '';
  alarmstrings[2]:= 'HAlarm';
  nt := 1;

  tags[0] := '';
  lc[0]:= 14;
  lf[0] := 0;
  rtinitwindowcolors(rtstat[3],0,0,9,12,15,15,15);

  rtsetupvbargraph(rtstat[3], -1.0, 1.0, 0.0, -0.8, 0.8, 200.0,
		       2,'Dias. Pres.',  units, tags, alarmstrings,1,lc, lf);
  lc[0]:= 9;
  lf[0] := 0;
  rtinitwindowcolors(rtstat[4],0,0,9,12,15,15,15);
  rtsetuppiemeter(rtstat[4],0.0, 10.0, 0.0, 0.5,
		  0.5, 0.4, 1,180, 1.0, 9.0, 5.0,1,
		  '','O2 L/min',tags,alarmstrings,
		  1,5, 1, lc,lf);
  rtborderwindow(rtstat[4],9);


  index := 0;
  o2index := 1.0;
  o2i := 1;
  REPEAT
    yvalues[0] :=  ydata[index mod 500];
    rtupdatescrollgraph(rtstat[0],yvalues);
    rtupdatevbargraph(rtstat[3], yvalues);

    yvalues[0] :=  ydata3[index mod 500];
    rtupdatescrollgraph(rtstat[1],yvalues);

    if (index  MOD 3 = 0) then
    BEGIN
      rr := random;
      yvalues[0] := 130.0 + rr;
      rr := random;
      yvalues[1] := 85.0 + rr;
      if (index < 200) then
	yvalues[2] := 66.0
      else
	yvalues[2] := 67.5;
      yvalues[3] := 0.82;
      rtupdateannun(rtstat[2],yvalues);

    END;
    if (index mod 10 = 0 ) then
    BEGIN
       yvalues[0] := o2index + rr;
       o2index := o2index + o2i;
       if (o2index >= 8.0) then o2i := -1.0;
       if (o2index <= 1.0) then o2i := 1.0;
       rtupdatepiemeter(rtstat[4], yvalues);
    END;
    INC(index, 1);
    cursec := Getseconds;
  until (CheckEvent <> 0) or (cursec > startsec+15);
  IF (checkevent = 1) THEN CH := getkey;
END;

procedure BuildAp3;
VAR  timewords: rttimetype;
     j,i,timecntr: INTEGER;
    cursec,startsec: realtype;
BEGIN
  RTCLEARSCREEN;
  RTResetWindowDefaults(20);
  for i := 0 to 510 do
  begin
    rr := i;
    xdata[i] := i+1;
    ydata[i] :=  200 + 500 * (1-exp(-rr/100));
    ydata2[i] :=  300 + 400 * (1-exp(-rr/300));
  end;
  startsec := GetSeconds;
  lf[0]:= 0; lf[1] := 0; lf[2] := 0;
  for i := 0 to 7 do
  begin
    lc[i] := 1+3*i;
    lc2[i] := 15;
    case i of
    0: tags[i] := 'Temp01';
    1: tags[i] := 'Temp02';
    2: tags[i] := 'Temp03';
    3: tags[i] := 'Flow01';
    4: tags[i] := 'Flow02';
    5: tags[i] := 'Flow03';
    else
       tags[i] := 'TempXX';
    end;
    lalarm[i] := 350; halarm[i] := 650; stpnt[i] := 350;
    if i < 3 then units[i] := 'Fahr.' else
    if i < 6 then units[i] := 'GPM' else
    units[i] := 'Fahr.';
    halarms[i] := 'HIGH';
    lalarms[i] := 'LOW';
    nalarms[i] := 'OK';
    message[i] := 'RTSUBS';
  end;
  for i := 0 to 9 do
    if i < 6 then farray[i] := true else farray[i] := false;
  alarmstrings[0] := 'LOW';
  alarmstrings[1] := 'OK';
  alarmstrings[2] := 'HIGH';

  rtsetpercentwindow(rtstat[1],0.00,0.10,0.13,0.42);
  rtsetpercentwindow(rtstat[2],0.135,0.10,0.38,0.42);
  rtsetpercentwindow(rtstat[3],0.385,0.10,0.49,0.42);
  rtsetpercentwindow(rtstat[4],0.00,0.43,0.49,0.75);
  rtsetpercentwindow(rtstat[5],0.00,0.76,0.41,0.99);

  rtsetpercentwindow(rtstat[6],0.51,0.10,0.64,0.42);
  rtsetpercentwindow(rtstat[7],0.645,0.10,0.89,0.42);
  rtsetpercentwindow(rtstat[8],0.895,0.10,0.999,0.42);
  rtsetpercentwindow(rtstat[9],0.51,0.43,0.999,0.75);
  rtsetpercentwindow(rtstat[10],0.59,0.76,0.999,0.99);

  rtsetpercentwindow(rtstat[11],0.0,0.0,0.49,0.095);
  rtsetpercentwindow(rtstat[12],0.51,0.0,0.999,0.095);

  rtsetpercentwindow(rtstat[13],0.415,0.76,0.585,0.99);

  for i := 1 to 13 do
  begin
    rtsetwintextstyle(rtstat[i],0,1);
    if i in [1,2,3,6,7,8] then
      rtinitwindowcolors(rtstat[i],0,0,2,4,15,15,15);
    if i in [4,9] then
    begin
      rtinitwindowcolors(rtstat[i],7,0,10,4,15,15,15);
    end;
    case i of
    1: begin
       lc[0] := 9;
       tags[0] := 'Tach';
    rtsetupvbargraph(rtstat[i],0,1000,0,
                        350,700,550,0,'Eng #1','RPM',tags,alarmstrings,1,lc,lf);
       end;
    2: begin
       tags[0] := 'Cyl1';
       tags[1] := 'Cyl2';
       tags[2] := 'Cyl3';
       tags[3] := 'Cyl4';
         rtsetupvbargraph(rtstat[i],0,1000,0,
                        350,700.0,550.0,0,'Eng #1 Temp.','Fahr.',tags,alarmstrings,3,lc,lf);
       end;
    3: begin
         tags[0] := 'FUEL';
         rtsetuppiemeter(rtstat[i],0.0, 16.0,0.0, 0.7, 0.5, 0.5,90, 270,
                    2,15,-1,0,'Eng #1','Gallons',tags,alarmstrings,1,8,4,
                    lc,lf);
       end;
    4: begin
       tags[0] := 'Cyl1';
       tags[1] := 'Cyl2';
        rtsetupscrollgraph(rtstat[i],1.0,0.01,0,1000.0,0.90,2,1,300.0, 700.0,
                           550,2,0,'Eng #1 Cylinder Pressure','PSI',tags,lc,lf,false);
       lc[0] := 1;
       lc[1] := 4;
      end;
    5: begin
      rtinitwindowcolors(rtstat[i],7,0,2,4,15,15,15);
        farray[2] := FALSE;
  IF (GetMaxColor=1) THEN
    rtinitwindowcolors(rtstat[i],0,0,0,0,15,15,15);
        rtsetupannun(rtstat[i],lalarm,halarm, stpnt, 1, 'ANNUNCIATOR', units,tags,
                    halarms, lalarms,nalarms,2,2,lc2,farray);
        farray[2] := TRUE;
       end;
    6: begin
        lc[0] := 9;
        tags[0] := 'Tach';
        rtsetupvbargraph(rtstat[i],0,1000,0,
                        350,700,550,0,'Eng. #2','RPM',tags,alarmstrings,1,lc,lf);
       end;
    7: begin
       tags[0] := 'Cyl1';
       tags[1] := 'Cyl2';
       tags[2] := 'Cyl3';
       tags[3] := 'Cyl4';
        rtsetupvbargraph(rtstat[i],0,1000.0,0,
                        350,700.0,550,0,'Eng #2 Temp.','Fahr.',tags,alarmstrings,3,lc,lf);
       end;
    8: begin
         tags[0] := 'FUEL';
         rtsetuppiemeter(rtstat[i],0.0, 16.0,0.0, 0.7, 0.5, 0.5,90, 270,
                    2,15,-1,0,'Eng #2','Gallons',tags,alarmstrings,1,8,4,
                    lc,lf);
       end;
    9: begin
       tags[0] := 'Cyl1';
       tags[1] := 'Cyl2';
        rtsetupscrollgraph(rtstat[i],1.0,0.01,0,1000.0,0.90,2,1,300.0, 650.0,
                           550,2,0,'Eng #2 Cylinder Pressure','PSI',tags,lc,lf,false);
       lc[0] := 1;
       lc[1] := 4;
      end;
    10: begin
  IF (GetMaxColor=1) THEN
    rtinitwindowcolors(rtstat[i],0,0,0,0,15,15,15)
  ELSE
      rtinitwindowcolors(rtstat[i],7,0,2,4,15,15,15);
          rtsetupannun(rtstat[i],lalarm,halarm, stpnt, 1, 'ANNUNCIATOR', units,tags,
                    halarms, lalarms,nalarms,1,4,lc2,farray);

        end;
    11: begin
          settextstyle(0,0,2);
          rttitlewindow(rtstat[i],'Dyno Test Eng #1');
          settextstyle(0,0,1);
        end;
    12: begin
          settextstyle(0,0,2);
          rttitlewindow(rtstat[i],'Dyno Test Eng #2');
          settextstyle(0,0,1);
        end;
    13: begin
         lf[0] := 1; lf[1] := 1; lf[2] := 1;
         rtsetupclock(rtstat[13],'Test Duration',3,12,1,lc,lf);
        end;
    end;
    if i < 11 then rtborderwindow(rtstat[i],15);
  end;
  index := 0;
  IF mousefound THEN RtShowMouse;
  repeat
    yvalues[0] := ydata[index mod 500];
    yvalues[1] := 100 + ydata[(index+100) mod 500];
    yvalues[2] := ydata[(index+10) mod 500];
    yvalues[3] := ydata[(index+10) mod 500];

    y2values[0] := ydata2[index mod 500];
    y2values[1] := 100 + ydata2[(index+130) mod 500];
    y2values[2] := ydata2[(index+200) mod 500];
    y2values[3] := ydata2[(index+75) mod 500];

    y3values[0] := 10.5;

    yvalues[4] := ydata[(index+20) mod 500];
    yvalues[5] := ydata[(index+20) mod 500];
    for i := 1 to 13 do
    begin
      if (i = 10) or ((index mod 10) = 0) then
      begin
        if i = 13 then
        begin
          gettime(timewords[0],timewords[1], timewords[2],timewords[3]);
          for j := 0 to 3 do yvalues[j] := timewords[j];
          inc( timecntr,1);
        end;
        case i of
        1,2,5,13: if (index mod 4) = 0 THEN rtupdatedisplay(rtstat[i],yvalues);
        4:rtupdatedisplay(rtstat[i],yvalues);
         3,8: if (index mod 4) = 0 THEN rtupdatedisplay(rtstat[i],y3values);
        6,7,10,11,12: if (index mod 4) = 0 THEN rtupdatedisplay(rtstat[i],y2values);
        9: rtupdatedisplay(rtstat[i],y2values);
        end;
      end;
    end;
    inc(index,1);
    cursec := Getseconds;
  until (CheckEvent <> 0) or (cursec > startsec+15);
  IF (checkevent = 1) THEN CH := getkey;

END;

procedure BuildAp2;
VAR  ll,tt,bb: RealType;
     ss: string;
     radio: RTValueArrayType;
     i,j: INTEGER;
    cursec,startsec: realtype;
BEGIN
  RTCLEARSCREEN;
  RTResetWindowDefaults(20);
  FOR i := 0 TO 510 DO
  BEGIN
    rr := i;
    xdata[i] := i+1;
    ydata[i] :=  20 + 530 * (1-exp(-rr/10)) +
        300 * sin(rr/10) * (exp(-rr/20));
  END;
  lf[0]:= 0; lf[1] := 0; lf[2] := 0;
  for i := 0 to 7 do
  begin
    HalarmS[i] := 'HIGH';
    LalarmS[i] := 'LOW';
    NalarmS[i] := 'OK';
    lalarm[i] := 0;
    halarm[i] := 700;
    stpnt[i] := 0;
    units[i] := '';
    lc[i] := 15-i;
    IF i = 0 THEN lc[i] := 10;
    IF i = 7 THEN lc[i] := 7;
  END;
  radio[0] := 90.9;
  farray[0] := TRUE;
  farray[1] := FALSE;
  farray[2] := FALSE;
  farray[3] := FALSE;
  alarmStrings[0] := 'LOW';
  alarmStrings[1] := 'OK';
  alarmStrings[2] := 'HIGH';
  ll := 0;
  bb := 0.25;
  tt := 0.0;
  rr := ll + 1.0/8.0;
  FOR i := 0 to 1 do
  BEGIN
    FOR j := 0 to 7 do
    BEGIN
      RTSetPercentWindow(rtstat[i*8+j],ll,tt,rr,bb);
      ll := ll + 1.0/8.0; rr := rr + 1.0/8.0;
    END;
    bb := bb + 0.25;
    tt := tt + 0.25;
    ll := 0;
    rr := ll + 1.0/8.0;
  END;
  RTSetPercentWindow(rtstat[16],0.0,0.50,0.25,1.0);
  RTSetPercentWindow(rtstat[17],0.25,0.50,1.0,1.0);
  FOR i := 0 to 15 do
  begin
         str(i:1,ss);
         tags[0] := 'CV'+ss;
         RTSetupVBarGraph(rtstat[i],0,800.0,0.0,200.0,740.0,550.0,
                      0, ' ','Cent.',tags,alarmStrings,1,lc,lf);
         rtborderwindow(rtstat[i],15);
  end;
         tags[0] := 'RT1';
         tags[1] := 'RT2';
         tags[2] := 'RT3';
         tags[3] := 'RT4';
         tags[4] := 'RT5';
         tags[5] := 'RT6';
         tags[6] := 'RT7';
         tags[7] := 'RT8';
  RTSetupHBarGraph(rtstat[16],0,800.0,0.0,200.0,750.0,550.0,
                      0, ' ','Cent.',tags,alarmStrings,8,lc,lf);
  rtborderwindow(rtstat[16],15);
  RTInitWindowColors(rtstat[17],1,0,10,12,15,15,15);
  lc[0] := 14;
  RTSetupScrollGraph(rtstat[17],1.0,0.01,0,800.0,0.95,1,1,75.0, 750.0,
                           550,2,0,'Trend Graph','Temp.',tags,lc,lf,TRUE);
  RTTitleXAxis(rtstat[17],'Minutes');
  rtborderwindow(rtstat[17],15);
  index := 0;
  startsec := GetSeconds;
  IF mousefound THEN RtShowMouse;
  REPEAT
    yvalues[0] := ydata[index mod 500];
    yvalues[1] := 550 + 100 * random;
    yvalues[2] := 375 + 100 * random;
    yvalues[3] := 550 + 100 * random;
    yvalues[4] := 375 + 100 * random;
    yvalues[5] := 550 + 100 * random;
    yvalues[6] := 375 + 100 * random;
    yvalues[7] := 375 + 100 * random;

    for i := 0 to 17 do
    BEGIN
       yvalues[0] := yvalues[0] + (0.5-random)*10;
       if i IN [3,7,11] THEN
         RTUpdateDisplay(rtstat[i],radio)
       ELSE
         RTUpdateDisplay(rtstat[i],yvalues);
    END;
    INC(Index,1);
    cursec := Getseconds;
  until (CheckEvent <> 0) or (cursec > startsec+15);
  IF (checkevent = 1) THEN CH := getkey;

END;

procedure BuildAp1;
VAR i: INTEGER;
     radio, equal,pressure, temp, tach, speed, fuel, battery: RTValueArrayType;
    cursec,startsec: realtype;
BEGIN
  RTCLEARSCREEN;
  RTResetWindowDefaults(20);
  FOR i := 0 TO 599 DO
  BEGIN
    rr := i;
    xdata[i] := i+1;
    ydata[i] :=  200 + 500 * (1-exp(-rr/100));
  END;
  pressure[0] := 120;
  temp[0] := 175;
  tach[0] := 3500;
  speed[0] := 110;
  fuel[0] := 6.5;
  battery[0] := 12.5;
  radio[0] := 90.9;
  equal[0] := 70;
  equal[1] := 60;
  equal[2] := 85;
  equal[3] := 55;
  lf[0]:= 0; lf[1] := 0; lf[2] := 0;
  for i := 0 to 7 do
  begin
    HalarmS[i] := 'HIGH';
    LalarmS[i] := 'LOW';
    NalarmS[i] := 'OK';
    lalarm[i] := 0;
    halarm[i] := 700;
    stpnt[i] := 0;
    units[i] := '';
    lc2[i] := 15;
  END;
  farray[0] := TRUE;
  farray[1] := FALSE;
  farray[2] := FALSE;
  farray[3] := FALSE;
  alarmStrings[0] := 'LOW';
  alarmStrings[1] := 'OK';
  alarmStrings[2] := 'HIGH';

  RTSetPercentWindow(rtstat[1],0.0,0.0,0.999,0.10);
  RTSetPercentWindow(rtstat[2],0.0,0.11,0.155,0.32);
  RTSetPercentWindow(rtstat[3],0.0,0.33,0.155,0.55);
  RTSetPercentWindow(rtstat[4],0.16,0.11,0.50,0.55);
  RTSetPercentWindow(rtstat[5],0.51,0.11,0.85,0.55);
  RTSetPercentWindow(rtstat[6],0.855,0.11,0.999,0.32);
  RTSetPercentWindow(rtstat[7],0.855,0.33,0.999,0.55);

  RTSetPercentWindow(rtstat[8],0.0,0.56,0.5,0.999);
  RTSetPercentWindow(rtstat[9],0.60,0.56,0.999,0.80);
  RTSetPercentWindow(rtstat[10],0.60,0.81,0.999,0.999);

  FOR i := 1 to 10 do
  begin
    CASE i of
    1: BEGIN
        tags[0] := 'Temp.';
        tags[1] := 'Alt.';
        tags[2] := 'Battery';
        tags[3] := 'Brakes';
        tags[4] := 'Fuel';
        tags[5] := 'Lights';
        tags[6] := 'Door';
        tags[7] := 'Security';
  IF (GetMaxColor=1) THEN
    rtinitwindowcolors(rtstat[i],0,0,0,0,15,15,15);
          RTSetupAnnun(rtstat[i],lalarm,halarm, stpnt, 1, '', units,tags,
                    HalarmS, LalarmS,NalarmS,1,8,lc2,farray);

        END;
    2: BEGIN
         lc[0] := 15;
         lf[0] := 2;
         tags[0] := '';
  RTInitWindowColors(rtstat[i],1,7,2,4,15,15,15);
         RTSetupMeter(rtstat[i],0.0,200.0,0.50, 0.55, 0.38,0, 180,
                    10,150,100,0,'Oil','PSI',tags,alarmstrings,1,8,4,
                    lc,lf);
       END;
    3: BEGIN
         lc[0] := 15;
         tags[0] := '';
  RTInitWindowColors(rtstat[i],1,7,2,4,15,15,15);
         RTSetupMeter(rtstat[i],0.0, 250.0,0.49, 0.6, 0.38,0, 180,
                    100,180,155,0,'Temperature','Fahr.',tags,alarmstrings,1,8,4,
                    lc,lf);
       END;
    4: BEGIN
         lc[0] := 15;
         tags[0] := '';
  RTInitWindowColors(rtstat[i],1,1,2,4,15,15,15);
         RTSetupMeter(rtstat[i],0.0, 6000.0,0.5, 0.6, 0.49,330, 210,
                    500,5000,3000,0,'TACHOMETER','RPM',tags,alarmstrings,1,12,2,
                    lc,lf);
       END;
    5: BEGIN
         lc[0] := 15;
         lf[0] := 2;
         tags[0] := '';
  RTInitWindowColors(rtstat[i],1,1,2,4,15,15,15);
         RTSetupMeter(rtstat[i],0.0, 160.0,0.5, 0.6, 0.49,330, 210,
                    20,140,55,0,'SPEEDOMETER','MPH',tags,alarmstrings,1,16,2,
                    lc,lf);
       END;
    6: BEGIN
         lc[0] := 15;
         tags[0] := '';
  RTInitWindowColors(rtstat[i],1,7,2,4,15,15,15);
         RTSetupMeter(rtstat[i],0.0, 16.0,0.5, 0.6, 0.38,0, 180,
                    2,15,-1,0,'FUEL','Gal.',tags,alarmstrings,1,8,4,
                    lc,lf);
       END;
    7: BEGIN
         lc[0] := 15;
         tags[0] := '';
  RTInitWindowColors(rtstat[i],1,7,2,4,15,15,15);
         RTSetupMeter(rtstat[i],0.0, 16.0,0.5, 0.6, 0.38,0, 180,
                    8,15,-1,0,'Battery','Volts',tags,alarmstrings,1,8,4,
                    lc,lf);
       END;

    8:BEGIN
         lf[0] := 0;
       tags[0] := 'Cyl #1';
       tags[1] := 'Cyl #2';
       tags[2] := 'Cyl #3';
       tags[3] := 'Cyl #4';
       lc[0] := 10; lc[1] := 15; lc[2] := 14; lc[3] := 12;
       RTSetupScrollGraph(rtstat[i],1.0,0.01,0,1000.0,0.90,4,1,-300.0, -700.0,
                          -550,2,0,'Cylinder Temperature','Fahr.',tags,lc,lf,FALSE);
      END;
    9: BEGIN
       tags[0] := '.5K Hz';
       tags[1] := '1K Hz';
       tags[2] := '3K Hz';
       tags[3] := '6K Hz';
  alarmStrings[0] := '';
  alarmStrings[1] := '';
  alarmStrings[2] := '';
         RTSetupVBarGraph(rtstat[i],0,100.0,0.0,0.0,90.0,70.0,
                      0, 'Equalizer','DB',tags,alarmStrings,4,lc,lf);
       END;
    10: BEGIN
         tags[0] := '  ';
         RTSetupHBarGraph(rtstat[i],88,108.0,88,87.0,109.0,90.9,
                      1,'FM Radio','MHz',tags,alarmStrings,1,lc,lf);
       END;

    END;
    rtborderwindow(rtstat[i],15);
  end;
  index := 0;
  startsec := GetSeconds;
  REPEAT
  pressure[0] := 120+10*sin(index/20);
  temp[0] := 175+10*sin(index/20);
  tach[0] := 3500+510*sin(index/20);
  speed[0] := 110+10*sin(index/20);
  fuel[0] := 6.5-index/100;
  battery[0] := 12.5+2*sin(index/20);
  yvalues[0] := ydata[index mod 500];
  yvalues[1] := 100 + ydata[(index+50) mod 500];
  yvalues[2] := 200+ydata[(index+10) mod 500];
  yvalues[3] := 250+ydata[(index+10) mod 500];

  IF mousefound THEN RtShowMouse;
    for i := 1 to 10 do
    BEGIN
      CASE i OF
        1:RTUpdateDisplay(rtstat[i],yvalues);
        2: RTUpdateDisplay(rtstat[i],pressure);
        3: RTUpdateDisplay(rtstat[i],temp);
        4: RTUpdateDisplay(rtstat[i],tach);
        5: RTUpdateDisplay(rtstat[i],speed);
        6: RTUpdateDisplay(rtstat[i],fuel);
        7: RTUpdateDisplay(rtstat[i],battery);
        8: RTUpdateDisplay(rtstat[i],yvalues);
        9: RTUpdateDisplay(rtstat[i],equal);
        10: RTUpdateDisplay(rtstat[i],radio);
        END;
      END;
    INC(Index,1);
    cursec := Getseconds;
  until (CheckEvent <> 0) or (cursec > startsec+15);
  IF (checkevent = 1) THEN CH := getkey;

end;

Procedure BuildTCP2;
VAR numdat,i: INTEGER;
    CH: CHAR;
    yact, yest, xact: RealPntr;
    cursec,startsec: realtype;
BEGIN
  RTCLEARSCREEN;
  RTResetWindowDefaults(20);
  rtsetpercentwindow(rtstat[0],0.0,0.0,1.0,0.10);
  rtsetpercentwindow(rtstat[1],0.0,0.11,1.0,0.57);
  rtsetpercentwindow(rtstat[2],0.0,0.58,1.0,1.0);

  startsec := GetSeconds;
  FOR i := 0 to 2 do
    rtborderwindow(rtstat[i],15);
  SETTEXTSTYLE(2,0,7);
  CBoldTitle(rtstat[0],1,15,'Thermocouple Curvefitting');
  SETTEXTSTYLE(2,0,6);
  CWinText(rtstat[2],1,15,'Polynomial Curvefitting for All Thermocouple Types');
  CWinText(rtstat[2],2,15,'Temperature to Volts and Volts to Temperature');
  CWinText(rtstat[2],3,15,'Up to 20th Order Polynomials');
  CWinText(rtstat[2],4,15,'Fit Any Temperature Range');
  CWinText(rtstat[2],5,15,'Use Any Number of Breakpoints');
  CWinText(rtstat[2],6,15,'Summary Statistics for Quality of Curvefit');
  CWinText(rtstat[2],7,15,'Integrated Graphics');
  CWinText(rtstat[2],8,15,'Generalized Curvefitting Can Be Used for Other Applications');
  SETTEXTSTYLE(0,0,1);
  CWinText(rtstat[2],14,15,'PRESS ANY KEY TO CONTINUE');
  assign(tcfile,'JFILE.TXT');
  reset(tcfile);
  i := 0;
  numdat := 60;
  GetMem(yact,numdat*sizeof(RealType));
  GetMem(yest,numdat*sizeof(RealType));
  GetMem(xact,numdat*sizeof(RealType));
  while not(eof(tcfile)) do
  begin
    readln(tcfile,tcactual[i],tcfitted[i],tcxs[i]);
    PutPntrReal(yest,i,tcfitted[i]);
    PutPntrReal(yact,i,tcactual[i]);
    PutPntrReal(xact,i,tcxs[i]);
    inc(i,1);
  end;
  numdat := i-1;
  RTAutoAxes(rtstat[1],xact,yact,numdat,1);
  RTLinePlotData(rtstat[1],xact,yact,numdat,15,0);
  RTLinePlotData(rtstat[1],xact,yest,numdat,13,0);
  RTTitleWindow(rtstat[1],'J Thermocouple - Actual vs fitted values');
  RTTitleXAxis(rtstat[1],'Microvolts');
  RTTitleYAxis(rtstat[1],'Temp. Deg. C');

  IF mousefound THEN RtShowMouse;
  repeat
    cursec := Getseconds;
  until (CheckEvent <> 0) or (cursec > startsec+15);
  IF (checkevent = 1) THEN CH := getkey;
  FreeMem(yact,numdat*sizeof(RealType));
  FreeMem(yest,numdat*sizeof(RealType));
  FreeMem(xact,numdat*sizeof(RealType));
END;



Procedure BuildTCP1;
VAR i: INTEGER;
    CH: CHAR;
    cursec,startsec: realtype;
BEGIN
  RTCLEARSCREEN;
  RTResetWindowDefaults(20);
  rtsetpercentwindow(rtstat[0],0.0,0.0,1.0,0.10);

  rtsetpercentwindow(rtstat[1],0.0,0.11,1.0,1.0);

  FOR i := 0 to 1 do
    rtborderwindow(rtstat[i],15);
  SETTEXTSTYLE(2,0,7);
  CBoldTitle(rtstat[0],1,15,'Thermocouple Linearization');
  SETTEXTSTYLE(2,0,6);
  CWinText(rtstat[1],1,15,'All NBS-125 Thermocouple Types Supported');
  CWinText(rtstat[1],2,15,'Thermocouple Type      Temperature Range');
  CWinText(rtstat[1],3,15,'     B                   0 to 1820 C  ');
  CWinText(rtstat[1],4,15,'     BP                  0 to 1820 C  ');
  CWinText(rtstat[1],5,15,'     BN                  0 to 1820 C  ');
  CWinText(rtstat[1],6,15,'     E                -270 to 1000 C  ');
  CWinText(rtstat[1],7,15,'     J                -210 to 1200 C  ');
  CWinText(rtstat[1],8,15,'     JP               -210 to  760 C  ');
  CWinText(rtstat[1],9,15,'     JN               -210 to  760 C  ');
  CWinText(rtstat[1],10,15,'     K                -270 to 1372 C  ');
  CWinText(rtstat[1],11,15,'     KP               -270 to 1372 C  ');
  CWinText(rtstat[1],12,15,'     KN               -270 to 1372 C  ');
  CWinText(rtstat[1],13,15,'     R                 -50 to 1767.7 C');
  CWinText(rtstat[1],14,15,'     S                 -50 to 1767.7 C');
  CWinText(rtstat[1],15,15,'     T                -270 to  400 C  ');
  CWinText(rtstat[1],16,15,'     TP               -270 to  400 C  ');
  CWinText(rtstat[1],17,15,'     TN               -270 to  400 C  ');
  CWinText(rtstat[1],18,15,'Cold Junction Compensation');
  CWinText(rtstat[1],19,15,'Easily Modified for Any Range and Any Accuracy');
  SETTEXTSTYLE(0,0,1);
  CWinText(rtstat[1],30,15,'PRESS ANY KEY TO CONTINUE');
  IF mousefound THEN RtShowMouse;
  startsec := GetSeconds;
  repeat
    cursec := Getseconds;
  until (CheckEvent <> 0) or (cursec > startsec+15);
  IF (checkevent = 1) THEN CH := getkey;
END;

Procedure BuildPIDP2;
VAR i: INTEGER;
    CH: CHAR;
    cursec,startsec: realtype;
BEGIN
  RTCLEARSCREEN;
  RTResetWindowDefaults(20);
  rtsetpercentwindow(rtstat[0],0.0,0.0,1.0,0.10);

  rtsetpercentwindow(rtstat[1],0.0,0.11,1.0,1.0);

  FOR i := 0 to 1 do
    rtborderwindow(rtstat[i],15);
  SETTEXTSTYLE(2,0,7);
  CBoldTitle(rtstat[0],1,15,'PID Control');
  SETTEXTSTYLE(2,0,7);
  CWinText(rtstat[1],1,15,'Proportional - Integral - Derivative');
  CWinText(rtstat[1],2,15,'Anti-Reset Windup');
  CWinText(rtstat[1],3,15,'Bumpless Transfer');
  CWinText(rtstat[1],4,15,'Output Value Clamping');
  CWinText(rtstat[1],5,15,'Rate of Change Clamping');
  CWinText(rtstat[1],6,15,'Exponential Smoothing');
  CWinText(rtstat[1],7,15,'Flexible, Uses Engineering Units');
  CWinText(rtstat[1],8,15,'Position and Velocity PID Algorithms');
  CWinText(rtstat[1],9,15,'0.5 mSec / Update Using 20 MHz 386/387');
  SETTEXTSTYLE(0,0,1);
  CWinText(rtstat[1],30,15,'PRESS ANY KEY TO CONTINUE');
  IF mousefound THEN RtShowMouse;
  startsec := GetSeconds;
  repeat
    cursec := Getseconds;
  until (CheckEvent <> 0) or (cursec > startsec+15);
  IF (checkevent = 1) THEN CH := getkey;
END;


Procedure BuildPID1;
VAR i: INTEGER;
    CH: CHAR;
    cursec,startsec: realtype;
BEGIN
  RTCLEARSCREEN;
  RTResetWindowDefaults(20);
  rtsetpercentwindow(rtstat[0],0.0,0.0,1.0,0.10);

  RTSetPercentWindow(rtstat[1],0.0,0.11,0.99,0.49);
  RTSetPercentWindow(rtstat[2],0.67,0.5,0.99,0.99);
  RTSetPercentWindow(rtstat[3],0.0,0.5,0.66,0.99);
  RTSetWin2PlotRatio(rtstat[3],0.0,0.0,0.0,0.0);

  SETTEXTSTYLE(2,0,7);
  CBoldTitle(rtstat[0],1,15,'PID Control');
  SETTEXTSTYLE(0,0,1);

  lf[0] := 0;

  RTSetupScrollGraph(rtstat[1],1.0,0.01,0,1000.0,0.90,1,1,200.0, 800.0,
                    550,2,0,'Reactor Vessel','Cent.',tags,lc,lf,FALSE);
  RTTitleXAxis(rtstat[1],'Minutes');

  tags[0] := 'CV Temp.';
  tags[1] := 'Setpoint';
  tags[2] := 'Heater';
  RTSetupVBarGraph(rtstat[2],0,1000.0,0.0,200.0,800.0,550.0,
                   0, 'Reactor Vessel','Cent.',tags,alarmStrings,3,lc,lf);
  DrawDiagram(rtstat[3]);
  FOR i := 0 to 3 do
    rtborderwindow(rtstat[i],15);
  IF mousefound THEN RtShowMouse;
  index := 0;
  FOR i := 0 TO 510 DO
  BEGIN
    rr := i;
    xdata[i] := i+1;
    ydata[i] :=  20 + 530 * (1-exp(-rr/10)) +
        300 * sin(rr/10) * (exp(-rr/20));
  END;
  startsec := GetSeconds;
  repeat
    yvalues[0] := ydata[index mod 500];
    yvalues[1] := 550;
    yvalues[2] := 1000.0-yvalues[0];
    for i := 1 to 2 do
    begin
      rtupdatedisplay(rtstat[i],yvalues);
      delay(20);
    end;
    inc(index,1);
    cursec := Getseconds;
  until (CheckEvent <> 0) or (cursec > startsec+15);
  IF (checkevent = 1) THEN CH := getkey;
END;


Procedure BuildAnnunP2;
VAR i: INTEGER;
    CH: CHAR;
    cursec,startsec: realtype;
BEGIN
  RTCLEARSCREEN;
  RTResetWindowDefaults(20);
  rtsetpercentwindow(rtstat[0],0.0,0.0,1.0,0.10);

  rtsetpercentwindow(rtstat[1],0.0, 0.11, 1.0,0.65);

  rtsetpercentwindow(rtstat[2],0.0,0.66,1.0,1.0);

  RTSetupText(rtstat[1],lalarm,halarm, stpnt, 1, 'TEXT DISPLAY', units,tags,
              HalarmS, LalarmS,NalarmS,message,12,lc,farray);

  FOR i := 0 to 2 do
    rtborderwindow(rtstat[i],15);
  SETTEXTSTYLE(2,0,7);
  CBoldTitle(rtstat[0],1,15,'Process Control Text');
  SETTEXTSTYLE(2,0,6);
  CWinText(rtstat[2],1,15,'Up to 16 Channels per Window');
  CWinText(rtstat[2],2,15,'Background Colors Change State with Alarms');
  CWinText(rtstat[2],3,15,'Display Tag Name, Units, Current Value');
  CWinText(rtstat[2],4,15,'Alarm Message for Alarm Conditions');
  CWinText(rtstat[2],5,15,'All Colors are User Programmable');
  SETTEXTSTYLE(0,0,1);
  CWinText(rtstat[2],10,15,'PRESS ANY KEY TO CONTINUE');
  IF mousefound THEN RtShowMouse;
  startsec := GetSeconds;
  repeat
    yvalues[0] := ydata[index mod 500];
    yvalues[1] := 100 + ydata[(index+100) mod 500];
    yvalues[2] := ydata[(index+10) mod 500];
    yvalues[3] := ydata[(index+10) mod 500];
    yvalues[4] := ydata[index mod 500];
    yvalues[5] := 100 + ydata[(index+100) mod 500];
    yvalues[6] := ydata[(index+10) mod 500];
    yvalues[7] := ydata[(index+10) mod 500];
    yvalues[8] := ydata[index mod 500];
    yvalues[9] := 100 + ydata[(index+100) mod 500];
    yvalues[10] := ydata[(index+10) mod 500];
    yvalues[11] := ydata[(index+10) mod 500];
    for i := 1 to 1 do
    begin
      IF ((INDEX MOD 8) = 0) then rtupdatedisplay(rtstat[i],yvalues);
    end;
    inc(index,1);
    delay(200);
    cursec := Getseconds;
  until (CheckEvent <> 0) or (cursec > startsec+15);
  IF (checkevent = 1) THEN CH := getkey;
END;



Procedure BuildAnnunP1;
VAR i: INTEGER;
    CH: CHAR;
    cursec,startsec: realtype;
BEGIN
  RTCLEARSCREEN;
  RTResetWindowDefaults(20);

  rtsetpercentwindow(rtstat[0],0.0,0.0,1.0,0.10);

  rtsetpercentwindow(rtstat[1],0.0, 0.11, 0.66,0.25);
  rtsetpercentwindow(rtstat[2],0.0,0.26,0.66, 0.65);
  rtsetpercentwindow(rtstat[3],0.67,0.11,1.0,  0.65);

  rtsetpercentwindow(rtstat[4],0.0,0.66,1.0,1.0);

  farray[2] := FALSE;
  IF (GetMaxColor=1) THEN
    rtinitwindowcolors(rtstat[1],0,0,0,0,15,15,15);
  rtsetupannun(rtstat[1],lalarm,halarm, stpnt, 1, 'ANNUNCIATOR', units,tags,
                   halarms, lalarms,nalarms,1,6,lc,farray);
  farray[2] := TRUE;
  IF (GetMaxColor=1) THEN
    rtinitwindowcolors(rtstat[2],0,0,0,0,15,15,15);
  rtsetupannun(rtstat[2],lalarm,halarm, stpnt, 1, 'ANNUNCIATOR', units,tags,
                   halarms, lalarms,nalarms,2,3,lc,farray);

  IF (GetMaxColor=1) THEN
    rtinitwindowcolors(rtstat[3],0,0,0,0,15,15,15);
  rtsetupannun(rtstat[3],lalarm,halarm, stpnt, 1, 'ANNUNCIATOR', units,tags,
                   halarms, lalarms,nalarms,3,2,lc,farray);

  FOR i := 0 to 4 do
    rtborderwindow(rtstat[i],15);
  SETTEXTSTYLE(2,0,7);
  CBoldTitle(rtstat[0],1,15,'Annunciators');
  SETTEXTSTYLE(2,0,6);
  CWinText(rtstat[4],1,15,'Up to 16 Channels per Window');
  CWinText(rtstat[4],2,15,'Specify N Rows by M Columns');
  CWinText(rtstat[4],3,15,'Background Colors Change State with Alarms');
  CWinText(rtstat[4],4,15,'Display Tag Name, Current Value, Units');
  CWinText(rtstat[4],5,15,'Alarm Message for Alarm Conditions');
  CWinText(rtstat[4],6,15,'All Colors are User Programmable');
  SETTEXTSTYLE(0,0,1);
  CWinText(rtstat[4],11,15,'PRESS ANY KEY TO CONTINUE');
  IF mousefound THEN RtShowMouse;
  startsec := GetSeconds;
  repeat
    yvalues[0] := ydata[index mod 500];
    yvalues[1] := 100 + ydata[(index+100) mod 500];
    yvalues[2] := ydata[(index+10) mod 500];
    yvalues[3] := ydata[(index+30) mod 500];
    yvalues[4] := ydata[(index+50) mod 500];
    yvalues[5] := ydata[(index+100) mod 500];
    delay(100);
    for i := 1 to 3 do
    begin
      rtupdatedisplay(rtstat[i],yvalues);
    end;
    inc(index,1);
    cursec := Getseconds;
  until (CheckEvent <> 0) or (cursec > startsec+15);
  IF (checkevent = 1) THEN CH := getkey;
END;

Procedure BuildMetersP2;
VAR wi,i,j: INTEGER;
    xx, yy, hh, ww: RealType;
    CH: CHAR;
    winstr,title, tag: string[16];
    cursec,startsec: realtype;
BEGIN
  RTCLEARSCREEN;
  RTResetWindowDefaults(20);
  hh := 0.33;
  ww := 0.33;
  for j := 0 to 2 do
    for i := 0 to 2 do
    begin
      xx := i * 0.33;
      yy := j * 0.33;
      wi := j*3+i+1;
      str(wi:1, winstr);
      title := 'BAR #' + winstr;
      tag := 'Pressure'+winstr;
      tags[0] := tag;
      rtsetpercentwindow(rtstat[wi],xx,yy,xx+ww,yy+hh);
      case wi of
      1: RTSetupMeter(rtstat[wi],0.0, 1000.0, 0.5, 0.6,0.30,0, 180,
                    300,800,400,0,'NEEDLE METER','PSI',tags,alarmstrings,1,10,2,
                    lc,lf);
      2: RTSetupMeter(rtstat[wi],0.0, 1000.0, 0.5, 0.5, 0.30,320, 220,
                    300,800,400,0,'NEEDLE METER','PSI',tags,alarmstrings,2,10,2,
                    lc,lf);
      3: RTSetupMeter(rtstat[wi],0.0, 1000.0, 0.5, 0.65, 0.40,20, 160,
                    300,800,400,0,'NEEDLE METER','PSI',tags,alarmstrings,1,10,2,
                    lc,lf);
      4: RTSetupPieMeter(rtstat[wi],-500.0, 500.0,0.0, 0.5, 0.5, 0.30,320,220,
                    30,400,300,0,'PIE METER','PSI',tags,alarmstrings,1,10,2,
                    lc,lf);
      5: RTSetupPieMeter(rtstat[wi],0.0, 1000.0,0.0, 0.5, 0.5, 0.30,320,220,
                    30,900,500,0,'PIE METER','PSI',tags,alarmstrings,1,10,2,
                    lc,lf);
      6: RTSetupPieMeter(rtstat[wi],0.0, 1000.0,0.0, 0.5, 0.5, 0.30,320,220,
                    30,900,500,0,'PIE METER','PSI',tags,alarmstrings,1,10,2,
                    lc,lf);
      7: RTSetupArcMeter(rtstat[wi],0.0, 1000.0,0.0, 0.5, 0.6, 0.40,300, 240,
                    300,900,500,0,'ARC METER','PSI',tags,alarmstrings,1,10,2,
                    lc,lf);
      8: RTSetupArcMeter(rtstat[wi],-1000.0, 1000.0,0.0, 0.5, 0.6, 0.40,300, 240,
                    300,900,500,0,'ARC METER','PSI',tags,alarmstrings,1,10,2,
                    lc,lf);
      9: RTSetupArcMeter(rtstat[wi],-1000.0, 1000.0,0.0, 0.5, 0.6, 0.40,300, 240,
                    300,900,500,0,'ARC METER','PSI',tags,alarmstrings,1,10,2,
                    lc,lf);
      end;
      rtborderwindow(rtstat[wi],15);
    end;

  index := 0;
  IF mousefound THEN RtShowMouse;
  startsec := GetSeconds;
  repeat
    yvalues[0] := ydata[index mod 500];
    yvalues[1] := 100 + ydata[(index+100) mod 500];
    yvalues[2] := ydata[(index+10) mod 500];
    yvalues[3] := ydata[(index+20) mod 500];
    yvalues[4] := ydata[(index+40) mod 500];
    yvalues[5] := ydata[(index+70) mod 500];
    for i := 1 to 9 do
    begin
      IF ((INDEX MOD 8) = 0) then rtupdatedisplay(rtstat[i],yvalues);
    end;
    inc(index,1);
    cursec := Getseconds;
  until (CheckEvent <> 0) or (cursec > startsec+15);
  IF (CheckEvent = 1) THEN CH := getkey;
END;


Procedure BuildMetersP1;
VAR i: INTEGER;
    CH: CHAR;
    cursec,startsec: realtype;
BEGIN
  RTCLEARSCREEN;
  RTResetWindowDefaults(20);
  rtsetpercentwindow(rtstat[0],0.0,0.0,1.0,0.10);

  rtsetpercentwindow(rtstat[1],0.0, 0.11, 0.33,0.65);
  rtsetpercentwindow(rtstat[2],0.34,0.11,0.66, 0.65);
  rtsetpercentwindow(rtstat[3],0.67,0.11,1.0,  0.65);

  rtsetpercentwindow(rtstat[4],0.0,0.66,1.0,1.0);
  RTSetupMeter(rtstat[1],0.0, 1000.0, 0.5, 0.5, 0.5,300, 240,
                    300,800,400,0,'NEEDLE METER','Fahr.',tags,alarmstrings,2,10,2,
                    lc,lf);
  RTSetupPieMeter(rtstat[2],0.0, 1000.0,0.0, 0.5, 0.5, 0.5,300,240,
                    30,900,500,0,'PIE METER','Fahr.',tags,alarmstrings,1,10,2,
                    lc,lf);
  RTSetupArcMeter(rtstat[3],0.0, 1000.0,0.0, 0.5, 0.5, 0.5,300, 240,
                    300,900,500,0,'ARC METER','Fahr.',tags,alarmstrings,1,10,2,
                    lc,lf);


  FOR i := 0 to 4 do
    rtborderwindow(rtstat[i],15);
  SETTEXTSTYLE(2,0,7);
  CBoldTitle(rtstat[0],1,15,'Needle Pie and Arc Meters');
  SETTEXTSTYLE(2,0,6);
  CWinText(rtstat[4],1,15,'Flexible Meter Window Sizing');
  CWinText(rtstat[4],2,15,'Programmable Meter Arc');
  CWinText(rtstat[4],3,15,'High and Low Alarm Markers');
  CWinText(rtstat[4],4,15,'PID Setpoint Marker');
  CWinText(rtstat[4],5,15,'Alarm Message for Alarm Conditions');
  CWinText(rtstat[4],6,15,'All Colors are User Programmable');
  SETTEXTSTYLE(0,0,1);
  CWinText(rtstat[4],11,15,'PRESS ANY KEY TO CONTINUE');
  IF mousefound THEN RtShowMouse;
  startsec := GetSeconds;
  repeat
    yvalues[0] := ydata[index mod 500];
    yvalues[1] := 100 + ydata[(index+100) mod 500];
    yvalues[2] := ydata[(index+10) mod 500];
    yvalues[3] := ydata[(index+10) mod 500];
    for i := 1 to 3 do
    begin
      IF ((INDEX MOD 8) = 0) then rtupdatedisplay(rtstat[i],yvalues);
    end;
    inc(index,1);
    cursec := Getseconds;
  until (CheckEvent <> 0) or (cursec > startsec+15);
  IF (checkevent = 1) THEN CH := getkey;
END;

Procedure BuildBargraphsP2;
CONST FontC: array[0..15] of INTEGER = (1,3,4,4,4,5,5,5,6,6,6,7,7,7,8,8);
VAR wi,i,j: INTEGER;
    xx, yy, hh, ww: RealType;
    CH: CHAR;
    winstr,title, tag: string[16];
    cursec,startsec: realtype;
BEGIN
  RTCLEARSCREEN;
  hh := 0.33;
  ww := 0.125;
  xx := 0.0;
  for j := 0 to 0 do
    for i := 0 to 7 do
    begin
      if i > 0 then xx := xx + ww + 0.005;
      yy := 0;
      ww := 0.08 + (i*0.011);
      hh := 0.20 + (i*0.035);
      wi := j*8+i+1;
      str(wi:1, winstr);
      title := 'BAR #' + winstr;
      tag := 'Temp'+winstr;
      tags[0] := tag;
      rtsetwintextstyle(rtstat[wi],2,fontC[wi]);
      case wi of
      0: rtsetpercentwindow(rtstat[wi],xx,yy,xx+ww,yy+hh);
      1: rtsetpercentwindow(rtstat[wi],xx,yy,xx+ww,yy+hh);
      2: rtsetpercentwindow(rtstat[wi],xx,yy,xx+ww,yy+hh);
      3: rtsetpercentwindow(rtstat[wi],xx,yy,xx+ww,yy+hh);
      4: rtsetpercentwindow(rtstat[wi],xx,yy,xx+ww,yy+hh);
      5: rtsetpercentwindow(rtstat[wi],xx,yy,xx+ww,yy+hh);
      6: rtsetpercentwindow(rtstat[wi],xx,yy,xx+ww,yy+hh);
      7: rtsetpercentwindow(rtstat[wi],xx,yy,xx+ww,yy+hh);
      8: rtsetpercentwindow(rtstat[wi],xx,yy,xx+ww,yy+hh);
      end;
      rtsetupvbargraph(rtstat[wi],0,100,0,25,80,55,0,
                   title,'Cent.',tags,alarmstrings,1,lc,lf);
      rtborderwindow(rtstat[wi],15);
    end;

  rtsetpercentwindow(rtstat[9],0.0,0.37,0.50,0.65);
  rtsetuphbargraph(rtstat[9],0,1000,0,350,700,550,0,
                   'BAR #9','Cent.',tags,alarmstrings,2,lc,lf);
  rtborderwindow(rtstat[9],15);

  rtsetpercentwindow(rtstat[10],0.51,0.45,1.0,0.65);
  rtsetuphbargraph(rtstat[10],0,1000,0,350,700,550,0,
                   'BAR #9','Cent.',tags,alarmstrings,1,lc,lf);
  rtborderwindow(rtstat[10],15);

  tags[0] := 'Temp17';
  rtsetpercentwindow(rtstat[17],0.0,0.66,0.50,1.0);
  rtsetupvbargraph(rtstat[17],0,1000,500,350,700,500,0,
                   'BAR #17','Cent.',tags,alarmstrings,6,lc,lf);
  rtborderwindow(rtstat[17],15);

  tags[0] := 'Temp18';
  rtsetpercentwindow(rtstat[18],0.51,0.66,1.0,1.0);
  rtsetuphbargraph(rtstat[18],0,1000,500,350,700,500,0,
                   'BAR #18','Cent.',tags,alarmstrings,6,lc,lf);
      rtborderwindow(rtstat[18],15);
  index := 0;
  IF mousefound THEN RTShowMouse;
  startsec := GetSeconds;
  repeat
    yvalues[0] := ydata[index mod 500]/10;
    yvalues[1] := 100 + ydata[(index+100) mod 500];
    yvalues[2] := ydata[(index+10) mod 500];
    yvalues[3] := ydata[(index+20) mod 500];
    yvalues[4] := ydata[(index+40) mod 500];
    yvalues[5] := ydata[(index+70) mod 500];
    for i := 1 to 18 do
    begin
      rtupdatedisplay(rtstat[i],yvalues);
    end;
    delay(100);
    inc(index,1);
    cursec := Getseconds;
  until (CheckEvent <> 0) or (cursec > startsec+15);
  IF (checkevent = 1) THEN   CH := getkey;
  for i := 1 to 18 do
    rtsetwintextstyle(rtstat[i],0,1);
END;


Procedure BuildBargraphsP1;
VAR i: INTEGER;
    CH: CHAR;
    cursec,startsec: realtype;
BEGIN
  RTResetWindowDefaults(20);
  RTCLEARSCREEN;
  rtsetpercentwindow(rtstat[0],0.0,0.0,1.0,0.10);
  rtsetpercentwindow(rtstat[1],0.0,0.11,0.20,0.65);
  rtsetpercentwindow(rtstat[2],0.21,0.11,0.55,0.65);
  rtsetpercentwindow(rtstat[3],0.56,0.11,1.0,0.35);
  rtsetpercentwindow(rtstat[4],0.56,0.36,1.0,0.65);
  rtsetpercentwindow(rtstat[5],0.0,0.66,1.0,1.0);

  rtsetupvbargraph(rtstat[1],0,1000,0,350,700,550,0,
                   'BARGRAPH #1','RPM',tags,alarmstrings,1,lc,lf);

  rtsetupvbargraph(rtstat[2],0,1000,0,350,700,550,0,
                   'BARGRAPH #2','RPM',tags,alarmstrings,4,lc,lf);

  rtsetupHbargraph(rtstat[3],0,1000,0,350,700,550,0,
                   'BARGRAPH #3','RPM',tags,alarmstrings,1,lc,lf);

  rtsetupHbargraph(rtstat[4],0,1000,0,350,700,550,0,
                   'BARGRAPH #4','RPM',tags,alarmstrings,4,lc,lf);

  FOR i := 0 to 5 do
    rtborderwindow(rtstat[i],15);
  SETTEXTSTYLE(2,0,7);
  CBoldTitle(rtstat[0],1,15,'Horizontal and Vertical Bargraphs');
  SETTEXTSTYLE(2,0,6);
  CWinText(rtstat[5],1,15,'Flexible Bargraph Window Sizing');
  CWinText(rtstat[5],2,15,'Up to 16 Bars per Bargraph Window');
  CWinText(rtstat[5],3,15,'High and Low Alarm Markers');
  CWinText(rtstat[5],4,15,'PID Setpoint Marker');
  CWinText(rtstat[5],5,15,'Alarm Messages for Alarm Conditions');
  CWinText(rtstat[5],6,15,'All Colors are User Programmable');
  SETTEXTSTYLE(0,0,1);
  CWinText(rtstat[5],11,15,'PRESS ANY KEY TO CONTINUE');
  IF mousefound THEN RTShowMouse;
  startsec := GetSeconds;
  repeat
    yvalues[0] := ydata[index mod 500];
    yvalues[1] := 100 + ydata[(index+100) mod 500];
    yvalues[2] := ydata[(index+10) mod 500];
    yvalues[3] := ydata[(index+10) mod 500];
    for i := 1 to 4 do
    begin
      IF ((INDEX MOD 8) = 0) then rtupdatedisplay(rtstat[i],yvalues);
    end;
    inc(index,1);
    cursec := Getseconds;
  until (CheckEvent <> 0) or (cursec > startsec+15);
  IF (checkevent = 1) THEN   CH := getkey;
END;


procedure OpenBanner;
var s1,s2,s3: string;
begin
  RTSetViewBackground(rtstat[0],0);
  RTBorderWindow(rtstat[0],15);
  s1 := 'IOtech REAL-TIME GRAPHICS';
  s2 := 'AND MEASUREMENT CONTROL TOOLS';
  s3 := 'FOR TURBO C, TURBO PASCAL AND MICROSOFT C';
  XText(s1,s2,s3,3);
END;

PROCEDURE SetupMainConstants;
var i: INTEGER;
BEGIN
  for i := 0 to 510 do
  begin
    rr := i;
    ydata[i] :=  500 + 300 * sin(rr/10);;
    ydata2[i] :=  500 + 300 * sin(rr/200);;
  END;
  lf[0]:= 0;
  lf[1] := 0;
  lf[2] := 0;
  for i := 0 to 15 do
  begin
    lc[i] := 2 + (i mod 4);
    lc2[i] := 15;
    case i of
    0: tags[i] := 'Temp01';
    1: tags[i] := 'Temp02';
    2: tags[i] := 'Temp03';
    3: tags[i] := 'Flow01';
    4: tags[i] := 'Flow02';
    5: tags[i] := 'Flow03';
    else
       tags[i] := 'TempXX';
    END;
    lalarm[i] := 350; halarm[i] := 650; stpnt[i] := 350;
    IF i < 3 THEN units[i] := 'Fahr' else
    IF i < 6 THEN units[i] := 'GPM' else
    units[i] := 'Fahr';
    halarms[i] := 'HIGH';
    lalarms[i] := 'LOW';
    nalarms[i] := 'OK';
    message[i] := 'RTSUBS';
  END;
  for i := 0 to 9 do
      IF i < 6 THEN farray[i] := true else farray[i] := false;
  alarmstrings[0] := 'LOW';
  alarmstrings[1] := 'OK';
  alarmstrings[2] := 'HIGH';

END;

PROCEDURE SetupMainWindows;
BEGIN
  rtsetpercentwindow(rtstat[0],0.0,0.0,1.0,0.10);
  rtsetpercentwindow(rtstat[1],0.0,0.11,0.33,0.55);
  rtsetpercentwindow(rtstat[2],0.34,0.11,0.66,0.55);
  rtsetpercentwindow(rtstat[3],0.67,0.11,1.0,0.55);
  rtsetpercentwindow(rtstat[4],0.0,0.56,0.33,1.0);
  rtsetpercentwindow(rtstat[5],0.34,0.56,0.69,0.82);
  rtsetpercentwindow(rtstat[6],0.70,0.56,1.0,0.82);
  rtsetpercentwindow(rtstat[7],0.34,0.83,0.69,1.0);
  rtsetpercentwindow(rtstat[8],0.70,0.83,1.0,1.0);
END;

PROCEDURE SetupMainGraphs(dobanner: BOOLEAN);
VAR i: INTEGER;
BEGIN
  setlinestyle(0,0,1);
  RTInitWindowColors(rtstat[1],1,1,2,4,15,15,15);
  RTSetupScrollGraph(rtstat[1],4.0,0.10,0,1000.0,0.97,1,0,-300.0, -700.0,
                          -550,1,0,'SCROLL GRAPHS - PRESS F1','Fahr.',
                          tags,lc,lf,FALSE);

  RTInitWindowColors(rtstat[2],1,0,2,4,15,15,15);
  rtsetupvbargraph(rtstat[2],0,1000,0,350,700,550,0,
                   'BARGRAPHS - PRESS F2','RPM',tags,alarmstrings,3,lc,lf);

  lf[0] := 3;
  lf[1] := 7;
  RTInitWindowColors(rtstat[3],1,1,2,4,15,15,15);
  RTSetupMeter(rtstat[3],0.0, 1000.0,0.50, 0.5, 0.45,320, 220,
                    100,800,550,0,'METERS - PRESS F3','Fahr.',
                    tags,alarmstrings,2,20,2,lc,lf);

  IF (GetMaxColor=1) THEN
   rtinitwindowcolors(rtstat[4],0,0,0,0,15,15,15) ELSE
   RTInitWindowColors(rtstat[4],1,1,2,4,15,15,15);
  rtsetupannun(rtstat[4],lalarm,halarm, stpnt, 1, 'ANNUNCIATORS - PRESS F4', units,tags,
                   halarms, lalarms,nalarms,2,2,lc2,farray);
  for i := 0 to 8 do
    RTBorderWindow(rtstat[i],15);

  settextstyle(2,0,6);
  CWinText(rtstat[5],1,15,'Press F5');
  CWinText(rtstat[5],2,15,'Thermocouple');
  CWinText(rtstat[5],3,15,'Curvefitting');
  CWinText(rtstat[5],4,15,'and');
  CWinText(rtstat[5],5,15,'Linearization');

  CWinText(rtstat[6],1,15,'Press F6');
  CWinText(rtstat[6],2,15,'Application');
  CWinText(rtstat[6],3,15,'Examples');

  CWinText(rtstat[7],1,15,'Press F7');
  CWinText(rtstat[7],2,15,'PID Control');

  CWinText(rtstat[8],1,15,'Press F8');
  CWinText(rtstat[8],2,15,'Quit');
  IF dobanner THEN OpenBanner;
  settextstyle(2,0,7);
  CBoldTitle(rtstat[0],1,15,'MAKE SELECTION - PRESS F1 - F8');
  settextstyle(0,0,1);
  CWinText(rtstat[0],3,15,'OR USE MOUSE TO SELECT');
END;

PROCEDURE RTExplodeWindow(wi, se, ee: INTEGER);
VAR incx1,incx2,incy1,incy2,kk,mx,my,x1,y1,x2,y2,i: INTEGER;
BEGIN
  for i := se to ee do
  begin
    IF i <> wi THEN
      RTClearWindow(rtstat[i]);
  END;
  SetViewport(0,0,GetMaxX, GetMaxY,FALSE);
  x1 := rtstat[wi]^.dr.left;
  x2 := rtstat[wi]^.dr.right;
  y1 := rtstat[wi]^.dr.top;
  y2 := rtstat[wi]^.dr.bottom;
  mx := getmaxx;
  my := getmaxy;
  kk := 0;
  incx1 := x1 div 16;
  incx2 := (mx - x2) div 16;
  incy1 := y1 div 16;
  incy2 := (my - y2) div 16;

  REPEAT
    DEC(x1,incx1);
    INC(x2,incx2);
    DEC(y1,incy1);
    INC(y2,incy2);
    setcolor(GetMaxColor);
    rtrectangleni(x1,y1,x2,y2);
    setcolor(0);
    rtrectangleni(x1,y1,x2,y2);
    INC(kk,1);
  UNTIL (kk > 16);
END;

FUNCTION UpdateMainGraphs: INTEGER;
VAR x,y,status,i,result: INTEGER;
    s: string;
BEGIN
  IF mousefound THEN RtShowMouse;
  REPEAT
    yvalues[0] := ydata[index mod 500];
    yvalues[1] := 100 + ydata[(index+100) mod 500];
    yvalues[2] := 200 + ydata[(index+100) mod 500];
    y2vals[0] := ydata2[index mod 500];
    y2vals[1] := 100 + ydata2[(index+100) mod 500];
    y2vals[2] := 150+ydata2[(index+10) mod 500];
    y2vals[3] := 200+ ydata2[(index+10) mod 500];
    for i := 1 to 4 do
    begin
      IF (i = 1) THEN rtupdatedisplay(rtstat[i],yvalues);
      IF ((index  mod 4)=0) and (i <> 1) THEN
      BEGIN
         rtupdatedisplay(rtstat[i],y2vals);
      END;
    END;
    inc(index,1);
  UNTIL (CheckEvent <> 0);
  IF (checkevent = 1) THEN  BEGIN
    s := getkey;
    val(s,result,i);
  END;
  IF (checkevent = 2) THEN
  BEGIN
    RTGetMouse(status,x,y);
    result := RTFindMouseWin(1,8,x,y);
  END;
  IF result > 0 THEN RTExplodeWindow(result,1,8);
  UpdateMainGraphs := result;
END;

PROCEDURE TextBox(left, top, w, h: WORD);
VAR xx,yy,i,j: WORD;
    blank: STRING;
    hl,vl,ul,ur,ll,lr: CHAR;
BEGIN
  xx := wherex; yy := wherey;
  blank := '';
  hl := #196; vl := #179; ul := #218;
  ur := #191; ll := #192; lr:= #217;
  BEGIN
    FOR i := 1 TO w-2 DO BEGIN gotoxy(left+i,top); write(hl); END;
    FOR i := 1 TO w-2 DO BEGIN gotoxy(left+i,top+h-1); write(hl); END;
    FOR j := 1 TO h-2 DO BEGIN gotoxy(left,top+j); write(vl); END;
    FOR j := 1 TO h-2 DO BEGIN gotoxy(left+w-1,top+j); write(vl); END;
    gotoxy(left,top); write(ul);
    gotoxy(left+w-1,top); write(ur);
    gotoxy(left,top+h-1); write(ll);
    gotoxy(left+w-1,top+h-1); write(lr);
    FOR j := 1 to h-2 do
    begin
      gotoxy(left+1,top+j);
      write(blank:(w-2));
    END;
  END;
  gotoxy(xx,yy);
END;

procedure OrderInfo;
VAR i: INTEGER;
BEGIn

  clrscr;
  TextBox(1,1,78,orderformlen+3);
  for i := 0 to orderformlen-1 do
  begin
    gotoxy(3,i+2);
    write(orderform[i]);
  end;
  writeln;
  writeln;
  writeln;
END;

procedure readorderform;
var i: INTEGER;
begin
  assign(orderformfile,'orderf.txt');
  reset(orderformfile);
  i := 0;
  while not(eof(orderformfile)) do
  BEGIN
    readln(orderformfile,orderform[i]);
    INC(i,1);
  END;
  orderformlen := i;
  close(orderformfile);
end;


begin

  index := 0;
 rtinitgraphics('',22,1);
  readorderform;
  RTInitMouse(mousefound,buttons);
  IF mousefound THEN
  BEGIN
    RTSetMouseIntr(4);
    RTSetMouseMaxX(0,GetMaxX);
    RTSetMouseMaxY(0,GetMaxY);
  END;
  mouseFound := FALSE;
  SetupMainWindows;
  SetupMainConstants;
  SetupMainGraphs(TRUE);
  IF mousefound THEN RTShowMouse;
  REPEAT
    mainaction := UpdateMainGraphs;
    CASE mainaction of
    1: BuildScrollP1;
    2: BEGIN
           BuildBargraphsP1 ;
           BuildBargraphsP2;
         END;
    3: BEGIN
           BuildMetersP1;
           BuildMetersP2;
         END;
    4: BEGIN
           BuildAnnunP1;
           BuildAnnunP2;
         END;
    5: BEGIN
         BuildTCP1;
         BuildTCP2;
       END;
    6: BEGIN
         BuildAp4;
         BuildAp1;
         BuildAp2;
         BuildAp3;
       END;
    7: BEGIN
         BuildPID1;
         BuildPIDP2;
       END;
    8: ;
    END;

    IF mainaction IN [1..7] THEN
    BEGIN
      RTResetWindowDefaults(20);
      RTCLEARSCREEN;
      SetupMainWindows;
      SetupMainConstants;
      SetupMainGraphs(FALSE);
    END;
  UNTIL mainaction = 8;
  RTCloseGraphics(1);
  orderinfo;
end.
